const alertsService = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);
var statusImages = new Array();
statusImages["NLN"] = "chrome://msnmsgr/skin/status/online.png";
statusImages["AWY"] = "chrome://msnmsgr/skin/status/away.png";
statusImages["BRB"] = "chrome://msnmsgr/skin/status/away.png";
statusImages["BSY"] = "chrome://msnmsgr/skin/status/busy.png";
statusImages["PHN"] = "chrome://msnmsgr/skin/status/busy.png";
statusImages["LUN"] = "chrome://msnmsgr/skin/status/busy.png";
statusImages["IDL"] = "chrome://msnmsgr/skin/status/idle.png";
statusImages["HDN"] = "chrome://msnmsgr/skin/status/offline.png";
statusImages["FLN"] = "chrome://msnmsgr/skin/status/offline.png";
statusImages["BLK"] = "chrome://msnmsgr/skin/status/blocked.png";

function onMainLoad() {
  window.bundle = getStringBundle("chrome://msnmsgr/locale/msnmsgr.properties");
  window.client = new MSNObject();
  document.getElementById("email").focus();
}

function onMainUnload() {
  closeSessionWindows();
  window.client.logout();
  delete window.client;
}

function changeNickname(nickname) {
  var currentNickname = document.getElementById("nickname").value;
  if (nickname.replace(/^\s+|\s+$/, '') != '' && nickname != currentNickname) {
    window.client.changeNickname(nickname);
    document.getElementById("nickname-deck").selectedIndex = "0";
  }
}

function changeStatus(status) {
  window.client.changeStatus(status);
}

function confirmContactAdd() {
  openWindowOnce("chrome://msnmsgr/contact/addcontact.xul", "msnsmgr:add-contact", "chrome");
}

function confirmContactDelete() {
  var tree = document.getElementById("contact-list-tree");
  var contactNode = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  if (confirm(window.bundle.GetStringFromName("contactDelete") + " " + contactNode.getAttribute("label") + " (" + contactNode.id + ")" + " ?")) {
    window.client.removeContact(contactNode.id, "FL");
  }
}

function contactlistDblClick(tree, event) {
  if (event.button == 0) {
    var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
    if (item.parentNode.parentNode.parentNode.id == "online-contacts-list") {
      setupSession();
    }
    else {
      if (item.id == "emailItem") {
        window.client.requestEmailURL("INBOX");
      }
    }
  }
}

function sendEmail() {
  var tree = document.getElementById("contact-list-tree");
  var item = tree.view.getItemAtIndex(tree.currentIndex);
  var itemParentID = item.parentNode.id;
  if (itemParentID == "online-contacts-list" || itemParentID == "offline-contacts-list") {
    window.client.requestEmailURL(item.firstChild.firstChild.id);
  }
}

function sendIM() {
  var tree = document.getElementById("contact-list-tree");
  var item = tree.view.getItemAtIndex(tree.currentIndex);
  if (item.parentNode.id == "online-contacts-list") {
    setupSession();
  }
}

function signIn() {
  var email = document.getElementById("email");
  var status = document.getElementById("initial-status").value;
  var re = /^.*\@.*\..*$/i; // valid e-mail in RegExp format
  var valid = re.exec(email.value); // check if the e-mail address is valid
  if (!valid) {
    var title = window.bundle.GetStringFromName("error");
    var text = window.bundle.GetStringFromName("invalidEMail");
    promptService.alert(window, title, text);
  }
  else {
    document.getElementById("signin-button").disabled = true;
    document.getElementById(status + "_menuitem").setAttribute("checked", true);
    document.getElementById("main-pages").selectedIndex = 1;
    window.client.logon(email.value, document.getElementById("password").value, status);
  }
}

function signOut() {
  document.getElementById("signin-button").disabled = false;
  document.getElementById("signin-progress").value = 0;
  document.getElementById("sign-in-status").label = '';
  document.getElementById("main-pages").selectedIndex = 0;
  var onlist = document.getElementById("online-contacts-list");
  while (onlist.firstChild) {
    onlist.removeChild(onlist.firstChild);
  }
  var offlist = document.getElementById("offline-contacts-list");
  while (offlist.firstChild) {
    offlist.removeChild(offlist.firstChild);
  }
  closeSessionWindows();
  window.client.logout();
  window.client = new MSNObject();
}

function toggleBlock() {
  var tree = document.getElementById("contact-list-tree");
  var contactNode = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  var contactID = contactNode.id;
  var nickname = contactNode.getAttribute("nickname");
  var status = window.client.getContactStatus(contactID);
  var blocked = window.client.isContactInList(contactID, "BL");
  if (blocked == true) {
    window.client.removeContact(contactID, "BL");
    window.client.addContact(contactID, "AL");
    contactChanged(contactID, nickname, status, blocked, 0);
  }
  else {
    window.client.removeContact(contactID, "AL");
    window.client.addContact(contactID, "BL");
    contactChanged(contactID, nickname, status, blocked, 0);
  }
}

function viewProfile() {
  var tree = document.getElementById("contact-list-tree");
  var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  if (item.id != "emailItem" && item.id != "online" && item.id != "offline") {
    window.open("http://members.msn.com/default.msnw?mem=" + item.id, "_BLANK");
  }
}

function addContact(contactID, nickname, status, blocked) {
  var list = document.getElementById("offline-contacts-list");
  var shownStatus;
  blocked ? shownStatus = "BLK" : shownStatus = status;
  ti = createContactNode(contactID, nickname, shownStatus);
  list.appendChild(ti);
}

function addOnlineContact(contactID, nickname, status, blocked) {
  var contactNode = document.getElementById(contactID);
  contactChanged(contactID, nickname, status, blocked, 0);
  var movingContactNode = document.getElementById("offline-contacts-list").removeChild(contactNode.parentNode.parentNode);
  document.getElementById("online-contacts-list").appendChild(movingContactNode);
}

function contactChanged(contactID, nickname, status, blocked, changes) {
  var contactNode = document.getElementById(contactID);
  var shownNickname;
  var shownStatus;
  contactNode.setAttribute("nickname", nickname);
  blocked ? shownStatus = "BLK" : shownStatus = status;
  if (shownStatus == "NLN" || shownStatus == "FLN") {
    shownNickname = nickname;
  }
  else {
    shownNickname = nickname + " (" + window.bundle.GetStringFromName("statusMsg" + shownStatus) + ")";
  }
  contactNode.setAttribute("label", " " + shownNickname);
  contactNode.setAttribute("src", statusImages[shownStatus]);
}

function contactSignedIn(contactID, nickname, status, blocked) {
  var shownNickname;
  addOnlineContact(contactID, nickname, status, blocked);
  if (nickname.length > 20) {
    shownNickname = nickname.substr(0, 20) + "...";
  }
  else {
    shownNickname = nickname;
  }
  alertsService.showAlertNotification("chrome://msnmsgr/skin/msnmsgr_small.png",
    window.bundle.GetStringFromName("msnNotification"), window.bundle.GetStringFromName("contactSignedIn").replace("%S", shownNickname), false, '', null);
}

function contactSignedOff(contactID, blocked) {
  var contactNode = document.getElementById(contactID);
  var nickname = contactNode.getAttribute("nickname");
  contactChanged(contactID, nickname, "FLN", blocked, 0);
  var movingContactNode = document.getElementById("online-contacts-list").removeChild(contactNode.parentNode.parentNode);
  document.getElementById("offline-contacts-list").appendChild(movingContactNode);
}

function getLocaleID() {
  return window.bundle.GetStringFromName("localeID");
}

window.getNickname = function() {
  return document.getElementById("nickname").value;
}

window.getStatusString = function(status) {
  return window.bundle.GetStringFromName("statusMsg" + status);
}

function loginEmail(action, login, username, sid, kv, id, sl, rru, auth, creds) {
  var win = window.open("about:blank");
  var form = win.document.createElement("form");
  form.setAttribute("action", action);
  form.setAttribute("method", "POST");
  appendInput("login", login);
  appendInput("username", username);
  appendInput("sid", sid);
  appendInput("kv", kv);
  appendInput("id", id);
  appendInput("sl", sl);
  appendInput("rru", rru);
  appendInput("auth", auth);
  appendInput("creds", creds);
  appendInput("svc", "mail");
  appendInput("js", "yes");
  win.document.body.appendChild(form);
  form.submit();

  function appendInput(name, value) {
    var input = win.document.createElement("input");
    input.setAttribute("type", "hidden");
    input.setAttribute("name", name);
    input.setAttribute("value", value);
    form.appendChild(input);
  }
}

function loginFailed(label) {
  var title = window.bundle.GetStringFromName("error");
  var text = window.bundle.GetStringFromName(label);
  promptService.alert(window, title, text);
  signOut();
}

function loginProgress(progressValue, progressText) {
  document.getElementById("signin-progress").value = progressValue;
  document.getElementById("sign-in-status").textContent = window.bundle.GetStringFromName(progressText);
}

function loginSuccessful() {
  document.getElementById("main-pages").selectedIndex = 2;
}

function newEmailReceived(from) {
  alertsService.showAlertNotification("chrome://msnmsgr/skin/msnmsgr_small.png",
    window.bundle.GetStringFromName("mailNotification"), window.bundle.GetStringFromName("newEmailFrom").replace("%S", from), false, '', null);
}

function nicknameChanged(nickname) {
  document.getElementById("nickname").value = nickname;
}

function removeContact(contactID) {
  var contactNode = document.getElementById(contactID);
  var list = contactNode.parentNode.parentNode.parentNode;
  list.removeChild(contactNode.parentNode.parentNode);
}

window.setNickname = function(nickname) {
  window.client.changeNickname(nickname);
}

function setupIncomingSession(contactID, host, port, cki, sessionID) {
  var sessionWindow = getSessionWindow(contactID);
  if (sessionWindow != null) {
    sessionWindow.answerIncomingSession(contactID, host, port, cki, sessionID);
  }
  else {
    window.openDialog("chrome://msnmsgr/content/session.xul", "_blank", "chrome,resizable,dialog=no",
      {contactID: contactID, client: window.client},
      {host: host, port: port, cki: cki, sessionID: sessionID} );
  }
}

function setupSession() {
  var tree = document.getElementById("contact-list-tree");
  var item = tree.view.getItemAtIndex(tree.currentIndex).firstChild.firstChild;
  var sessionWindow = getSessionWindow(item.id);
  if (sessionWindow == null) {
    window.openDialog("chrome://msnmsgr/content/session.xul", "_blank", "chrome,resizable,dialog=no",
      {contactID: item.id, client: window.client} );
  }
  else {
    sessionWindow.focus();
  }
}

function showError(label) {
  var title = window.bundle.GetStringFromName("error");
  var text = window.bundle.GetStringFromName(label);
  promptService.alert(window, title, text);
}

function statusChanged(status) {
  var statusImg = document.getElementById("status-image");
  var statusDesc = document.getElementById("status-description");
  statusImg.src = statusImages[status];
  statusDesc.value = window.bundle.GetStringFromName("yourStatusMsg").replace("%S", window.bundle.GetStringFromName("statusMsg" + status));
}

function updateEmailItem(emailCount) {
  switch (emailCount) {
    case 0:
      emailCount = window.bundle.GetStringFromName("noNewEmail");
      break;
    case 1:
      emailCount = window.bundle.GetStringFromName("oneNewEmail");
      break;
    default:
      emailCount = emailCount + " " +window.bundle.GetStringFromName("newEmail");
      break;
  }
  window.document.getElementById("emailItem").setAttribute("label", emailCount);
}

function broadcastContactChange(contactID, nickname, status) {
  var winEnum = winMediator.getEnumerator("msnmsgr:session");
  while (winEnum.hasMoreElements() == true) {
    var win = winEnum.getNext();
    win.contactChanged(contactID, nickname, status);
  }
}

function closeSessionWindows() {
  var winEnum = winMediator.getEnumerator("msnmsgr:session");
  while (winEnum.hasMoreElements() == true) {
    var win = winEnum.getNext();
    win.close();
  }
}

function createContactNode(contactID, nickname, status) {
  var ti = document.createElement("treeitem");
  var tr = document.createElement("treerow");
  var tc = document.createElement("treecell");
  var str = " " + nickname;
  if ((status != "NLN") && (status != "FLN")) {
    str += " (" + window.bundle.GetStringFromName("statusMsg" + status) + ")";
  }
  tc.setAttribute("label", str);
  tc.setAttribute("nickname", nickname);
  tc.setAttribute("id", contactID);
  tc.setAttribute("src", statusImages[status]);
  tr.appendChild(tc);
  ti.appendChild(tr);
  return ti;
}

function getSessionWindow(contactID) {
  var sessionWindow = null;
  var winEnum = winMediator.getEnumerator("msnmsgr:session");
  while (winEnum.hasMoreElements() == true) {
    var win = winEnum.getNext();
    var firstContactID = win.getFirstContactID();
    var contactCount = win.getContactCount();
    if (firstContactID == contactID && contactCount == 1) {
      sessionWindow = win;
    }
  }
  return sessionWindow;
}